<template>
  <aside
    class="lg:w-1/5 lg:block lg:relative lg:mt-0 dark:bg-black-500 lg:bg-transparent lg:dark:bg-transparent container fixed inset-0 z-30 mx-auto mt-16 bg-white"
    :class="{ block: menu, hidden: !menu }"
  >
    <div
      :class="{ 'border-l': menu }"
      class="lg:sticky lg:top-16 overflow-y-auto disable-scrollbars h-full lg:h-auto lg:max-h-(screen-16)"
    >
      <ul class="lg:py-6 lg:pl-0 lg:pr-8 p-4">
        <li v-if="!settings.algolia" class="lg:hidden my-4">
          <AppSearch />
        </li>
        <li
          v-for="(docs, category, index) in categories"
          :key="category"
          class="mb-4"
          :class="{
            active: isCategoryActive(docs),
            'lg:mb-0': index === Object.keys(categories).length - 1,
          }"
        >
          <p v-if="category" class="lg:text-xs mb-2 text-sm font-bold tracking-wider text-gray-500 uppercase">
            {{ category }}
          </p>
          <ul>
            <li v-for="doc of docs" :key="doc.slug" class="dark:text-gray-300 text-gray-700">
              <NuxtLink
                :to="localePath(doc.to)"
                class="hover:text-primary-500 flex items-center justify-between px-2 py-1 font-medium rounded"
                exact-active-class="text-primary-500 bg-primary-100 hover:text-primary-500 dark:bg-primary-900"
              >
                {{ doc.menuTitle || doc.title }}
              </NuxtLink>
            </li>
          </ul>
        </li>
        <div v-if="menu">
          <li v-for="navItem in navItems" :key="navItem.category" class="mb-4">
            <p v-if="navItem.category" class="lg:text-xs mb-2 text-sm font-bold tracking-wider text-gray-500 uppercase">
              {{ navItem.category }}
            </p>
            <ul>
              <li v-for="link in navItem.links" :key="link.name" class="dark:text-gray-300 text-gray-700">
                <a
                  :href="link.link"
                  class="hover:text-primary-500 flex items-center justify-between px-2 py-1 font-medium rounded"
                  exact-active-class="text-primary-500 bg-primary-100 hover:text-primary-500 dark:bg-primary-900"
                >
                  {{ link.name }}
                  <ArrowUpRight />
                </a>
              </li>
            </ul>
          </li>
        </div>
      </ul>
    </div>
  </aside>
</template>

<script>
import { mapGetters } from 'vuex'

export default {
  data() {
    return {
      navItems: [
        {
          category: 'About',
          links: [
            {
              name: 'Pitch',
              link: 'https://grey.software/pitch',
            },
            {
              name: 'FAQ',
              link: 'https://grey.software/faq',
            },
            {
              name: 'Feedback',
              link: 'https://grey.software/feedback',
            },
            {
              name: 'Analytics',
              link: 'https://grey.software/analytics',
            },
            {
              name: 'Philosophy',
              link: 'https://grey.software/philosophy',
            },
          ],
        },
        {
          category: 'Explore',
          links: [
            {
              name: 'Resources',
              link: 'https://resources.grey.software/',
            },
            {
              name: 'Onboarding',
              link: 'https://onboarding.grey.software/',
            },
            {
              name: 'Organization',
              link: 'https://org.grey.software/',
            },
            {
              name: 'Learn',
              link: 'https://learn.grey.software/',
            },
            {
              name: 'Glossary',
              link: 'https://glossary.grey.software/',
            },
          ],
        },
        {
          category: 'Socials',
          links: [
            {
              name: 'Twitter',
              link: 'https://twitter.com/grey_software',
            },
            {
              name: 'GitHub',
              link: 'https://github.com/grey-software',
            },
            {
              name: 'GitLab',
              link: 'https://gitlab.com/grey-software',
            },
            {
              name: 'Discord',
              link: 'http://community.grey.software',
            },
            {
              name: 'LinkedIn',
              link: 'https://www.linkedin.com/company/grey-software/',
            },
          ],
        },
      ],
    }
  },
  computed: {
    ...mapGetters(['settings', 'githubUrls']),
    menu: {
      get() {
        return this.$store.state.menu.open
      },
      set(val) {
        this.$store.commit('menu/toggle', val)
      },
    },
    categories() {
      return this.$store.state.categories[this.$i18n.locale]
    },
  },
  methods: {
    isCategoryActive(documents) {
      return documents.some((document) => document.to === this.$route.fullPath)
    },
    isDocumentNew(document) {
      if (process.server) {
        return
      }
      if (!document.version || document.version <= 0) {
        return
      }

      const version = localStorage.getItem(`document-${document.slug}-version`)
      if (document.version > Number(version)) {
        return true
      }

      return false
    },
  },
}
</script>
